
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.creativenether.init;

import net.minecraftforge.registries.RegistryObject;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.world.BiomeLoadingEvent;

import net.minecraft.world.level.levelgen.placement.PlacedFeature;
import net.minecraft.world.level.levelgen.feature.Feature;
import net.minecraft.world.level.levelgen.GenerationStep;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.core.Holder;

import net.mcreator.creativenether.world.features.plants.ToxicvinesFeature;
import net.mcreator.creativenether.world.features.plants.ToxicfungiFeature;
import net.mcreator.creativenether.world.features.ores.NethersouloreFeature;
import net.mcreator.creativenether.world.features.ores.BlobFeature;
import net.mcreator.creativenether.CreativeNetherMod;

import java.util.function.Supplier;
import java.util.Set;
import java.util.List;
import java.util.ArrayList;

@Mod.EventBusSubscriber
public class CreativeNetherModFeatures {
	public static final DeferredRegister<Feature<?>> REGISTRY = DeferredRegister.create(ForgeRegistries.FEATURES, CreativeNetherMod.MODID);
	private static final List<FeatureRegistration> FEATURE_REGISTRATIONS = new ArrayList<>();
	public static final RegistryObject<Feature<?>> TOXICVINES = register("toxicvines", ToxicvinesFeature::feature, new FeatureRegistration(
			GenerationStep.Decoration.VEGETAL_DECORATION, ToxicvinesFeature.GENERATE_BIOMES, ToxicvinesFeature::placedFeature));
	public static final RegistryObject<Feature<?>> TOXICFUNGI = register("toxicfungi", ToxicfungiFeature::feature, new FeatureRegistration(
			GenerationStep.Decoration.VEGETAL_DECORATION, ToxicfungiFeature.GENERATE_BIOMES, ToxicfungiFeature::placedFeature));
	public static final RegistryObject<Feature<?>> BLOB = register("blob", BlobFeature::feature,
			new FeatureRegistration(GenerationStep.Decoration.UNDERGROUND_ORES, BlobFeature.GENERATE_BIOMES, BlobFeature::placedFeature));
	public static final RegistryObject<Feature<?>> NETHERSOULORE = register("nethersoulore", NethersouloreFeature::feature, new FeatureRegistration(
			GenerationStep.Decoration.UNDERGROUND_ORES, NethersouloreFeature.GENERATE_BIOMES, NethersouloreFeature::placedFeature));

	private static RegistryObject<Feature<?>> register(String registryname, Supplier<Feature<?>> feature, FeatureRegistration featureRegistration) {
		FEATURE_REGISTRATIONS.add(featureRegistration);
		return REGISTRY.register(registryname, feature);
	}

	@SubscribeEvent
	public static void addFeaturesToBiomes(BiomeLoadingEvent event) {
		for (FeatureRegistration registration : FEATURE_REGISTRATIONS) {
			if (registration.biomes() == null || registration.biomes().contains(event.getName()))
				event.getGeneration().getFeatures(registration.stage()).add(registration.placedFeature().get());
		}
	}

	private static record FeatureRegistration(GenerationStep.Decoration stage, Set<ResourceLocation> biomes,
			Supplier<Holder<PlacedFeature>> placedFeature) {
	}
}
